#include <inttypes.h>
#include <vector>
#include "BlackBoxRuntime.hpp"

#define KNN_KVALUE 254

class EuclideanMetric
{
public:
  void setup(uint32_t nIn, uint32_t nOut, std::list<std::vector<double> >& aData) {}

  double
  operator()(uint32_t aCount,
             double* aArray,
             const std::vector<double>& aVector)
  {
    double dist = 0.0, t;
    uint32_t i;
    for (i = 0; i < aCount; i++)
    {
      t = aArray[i] - aVector[i];
      dist += t * t;
    }

    return dist;
  }
};

class ManhattanMetric
{
public:
  void setup(uint32_t nIn, uint32_t nOut, std::list<std::vector<double> >& aData) {}

  double
  operator()(uint32_t aCount,
             double* aArray,
             const std::vector<double>& aVector)
  {
    double dist = 0.0, t;
    uint32_t i;
    for (i = 0; i < aCount; i++)
    {
      t = aArray[i] - aVector[i];
      dist += fabs(t);
    }

    return dist;
  }
};

class PearsonCorrMetric
{
public:
  void setup(uint32_t nIn, uint32_t nOut, std::list<std::vector<double> >& aData) {}

  double
  operator()(uint32_t aCount,
             double* aArray,
             const std::vector<double>& aVector)
  {
    double sumx = 0.0, sumy = 0.0, sumx2 = 0.0, sumy2 = 0.0;
    uint32_t i;
    for (i = 0; i < aCount; i++)
    {
      double x = aArray[i], y = aVector[i];
      sumx += x;
      sumy += y;
      sumx2 += x * x;
      sumy2 += y * y;
    }

    double icount = 1.0 / aCount;
    sumx *= icount;
    sumy *= icount;
    sumx2 *= icount;
    sumy2 *= icount;
    double sdx = sqrt(sumx2 - sumx * sumx);
    double sdy = sqrt(sumy2 - sumy * sumy);
    double isdx = 1.0 / sdx, isdy = 1.0 / sdy;

    double dist = 0.0;

    for (i = 0; i < aCount; i++)
    {
      double x = aArray[i], y = aVector[i];
      double zx = (x - sumx) * isdx, zy = (y - sumy) * isdy;
      dist += zx * zy;
    }

    dist *= icount;

    return exp(-dist);
  }
};

class SignTestMetric
{
public:
  void setup(uint32_t nIn, uint32_t nOut, std::list<std::vector<double> >& aData) {}

  double
  operator()(uint32_t aCount,
             double* aArray,
             const std::vector<double>& aVector)
  {
    uint32_t i;
    uint32_t score = 0;
    for (i = 0; i < aCount; i++)
    {
      score += ((aArray[i] > 0) ^ (aVector[i] > 0));
    }

    return score;
  }
};

// one-tailed standard normal p-values from 0 to 2 in 0.01 increments.
double normal_pvalues[] =
{
  5.000000e-01, 4.960106e-01, 4.920217e-01, 4.880335e-01, 4.840466e-01,
  4.800612e-01, 4.760778e-01, 4.720968e-01, 4.681186e-01, 4.641436e-01,
  4.601722e-01, 4.562047e-01, 4.522416e-01, 4.482832e-01, 4.443300e-01,
  4.403823e-01, 4.364405e-01, 4.325051e-01, 4.285763e-01, 4.246546e-01,
  4.207403e-01, 4.168338e-01, 4.129356e-01, 4.090459e-01, 4.051651e-01,
  4.012937e-01, 3.974319e-01, 3.935801e-01, 3.897388e-01, 3.859081e-01,
  3.820886e-01, 3.782805e-01, 3.744842e-01, 3.707000e-01, 3.669283e-01,
  3.631693e-01, 3.594236e-01, 3.556912e-01, 3.519727e-01, 3.482683e-01,
  3.445783e-01, 3.409030e-01, 3.372427e-01, 3.335978e-01, 3.299686e-01,
  3.263552e-01, 3.227581e-01, 3.191775e-01, 3.156137e-01, 3.120669e-01,
  3.085375e-01, 3.050257e-01, 3.015318e-01, 2.980560e-01, 2.945985e-01,
  2.911597e-01, 2.877397e-01, 2.843388e-01, 2.809573e-01, 2.775953e-01,
  2.742531e-01, 2.709309e-01, 2.676289e-01, 2.643473e-01, 2.610863e-01,
  2.578461e-01, 2.546269e-01, 2.514289e-01, 2.482522e-01, 2.450971e-01,
  2.419637e-01, 2.388521e-01, 2.357625e-01, 2.326951e-01, 2.296500e-01,
  2.266274e-01, 2.236273e-01, 2.206499e-01, 2.176954e-01, 2.147639e-01,
  2.118554e-01, 2.089701e-01, 2.061081e-01, 2.032694e-01, 2.004542e-01,
  1.976625e-01, 1.948945e-01, 1.921502e-01, 1.894297e-01, 1.867329e-01,
  1.840601e-01, 1.814113e-01, 1.787864e-01, 1.761855e-01, 1.736088e-01,
  1.710561e-01, 1.685276e-01, 1.660232e-01, 1.635431e-01, 1.610871e-01,
  1.586553e-01, 1.562476e-01, 1.538642e-01, 1.515050e-01, 1.491700e-01,
  1.468591e-01, 1.445723e-01, 1.423097e-01, 1.400711e-01, 1.378566e-01,
  1.356661e-01, 1.334995e-01, 1.313569e-01, 1.292381e-01, 1.271432e-01,
  1.250719e-01, 1.230244e-01, 1.210005e-01, 1.190001e-01, 1.170232e-01,
  1.150697e-01, 1.131394e-01, 1.112324e-01, 1.093486e-01, 1.074877e-01,
  1.056498e-01, 1.038347e-01, 1.020423e-01, 1.002726e-01, 9.852533e-02,
  9.680048e-02, 9.509792e-02, 9.341751e-02, 9.175914e-02, 9.012267e-02,
  8.850799e-02, 8.691496e-02, 8.534345e-02, 8.379332e-02, 8.226444e-02,
  8.075666e-02, 7.926984e-02, 7.780384e-02, 7.635851e-02, 7.493370e-02,
  7.352926e-02, 7.214504e-02, 7.078088e-02, 6.943662e-02, 6.811212e-02,
  6.680720e-02, 6.552171e-02, 6.425549e-02, 6.300836e-02, 6.178018e-02,
  6.057076e-02, 5.937994e-02, 5.820756e-02, 5.705343e-02, 5.591740e-02,
  5.479929e-02, 5.369893e-02, 5.261614e-02, 5.155075e-02, 5.050258e-02,
  4.947147e-02, 4.845723e-02, 4.745968e-02, 4.647866e-02, 4.551398e-02,
  4.456546e-02, 4.363294e-02, 4.271622e-02, 4.181514e-02, 4.092951e-02,
  4.005916e-02, 3.920390e-02, 3.836357e-02, 3.753798e-02, 3.672696e-02,
  3.593032e-02, 3.514789e-02, 3.437950e-02, 3.362497e-02, 3.288412e-02,
  3.215677e-02, 3.144276e-02, 3.074191e-02, 3.005404e-02, 2.937898e-02,
  2.871656e-02, 2.806661e-02, 2.742895e-02, 2.680342e-02, 2.618984e-02,
  2.558806e-02, 2.499790e-02, 2.441919e-02, 2.385176e-02, 2.329547e-02,
  2.275013e-02, 2.221559e-02, 2.169169e-02, 2.117827e-02, 2.067516e-02,
  2.018222e-02, 1.969927e-02, 1.922617e-02, 1.876277e-02, 1.830890e-02,
  1.786442e-02, 1.742918e-02, 1.700302e-02, 1.658581e-02, 1.617738e-02,
  1.577761e-02, 1.538633e-02, 1.500342e-02, 1.462873e-02, 1.426212e-02,
  1.390345e-02, 1.355258e-02, 1.320938e-02, 1.287372e-02, 1.254546e-02,
  1.222447e-02, 1.191063e-02, 1.160379e-02, 1.130384e-02, 1.101066e-02,
  1.072411e-02, 1.044408e-02, 1.017044e-02, 9.903076e-03, 9.641870e-03,
  9.386706e-03, 9.137468e-03, 8.894043e-03, 8.656319e-03, 8.424186e-03,
  8.197536e-03, 7.976260e-03, 7.760254e-03, 7.549411e-03, 7.343631e-03,
  7.142811e-03, 6.946851e-03, 6.755653e-03, 6.569119e-03, 6.387155e-03,
  6.209665e-03, 6.036558e-03, 5.867742e-03, 5.703126e-03, 5.542623e-03,
  5.386146e-03, 5.233608e-03, 5.084926e-03, 4.940016e-03, 4.798797e-03,
  4.661188e-03, 4.527111e-03, 4.396488e-03, 4.269243e-03, 4.145301e-03,
  4.024589e-03, 3.907033e-03, 3.792562e-03, 3.681108e-03, 3.572601e-03,
  3.466974e-03, 3.364160e-03, 3.264096e-03, 3.166716e-03, 3.071959e-03,
  2.979763e-03, 2.890068e-03, 2.802815e-03, 2.717945e-03, 2.635402e-03,
  2.555130e-03, 2.477075e-03, 2.401182e-03, 2.327400e-03, 2.255677e-03,
  2.185961e-03, 2.118205e-03, 2.052359e-03, 1.988376e-03, 1.926209e-03,
  1.865813e-03, 1.807144e-03, 1.750157e-03, 1.694810e-03, 1.641061e-03,
  1.588870e-03, 1.538195e-03, 1.488999e-03, 1.441242e-03, 1.394887e-03,
  1.349898e-03, 1.306238e-03, 1.263873e-03, 1.222769e-03, 1.182891e-03,
  1.144207e-03, 1.106685e-03, 1.070294e-03, 1.035003e-03, 1.000782e-03,
  9.676032e-04, 9.354367e-04, 9.042552e-04, 8.740315e-04, 8.447392e-04,
  8.163523e-04, 7.888457e-04, 7.621947e-04, 7.363753e-04, 7.113640e-04,
  6.871379e-04, 6.636749e-04, 6.409530e-04, 6.189511e-04, 5.976485e-04,
  5.770250e-04, 5.570611e-04, 5.377374e-04, 5.190354e-04, 5.009369e-04,
  4.834241e-04, 4.664799e-04, 4.500872e-04, 4.342299e-04, 4.188919e-04,
  4.040578e-04, 3.897124e-04, 3.758409e-04, 3.624291e-04, 3.494631e-04,
  3.369293e-04, 3.248144e-04, 3.131057e-04, 3.017906e-04, 2.908571e-04,
  2.802933e-04, 2.700877e-04, 2.602292e-04, 2.507069e-04, 2.415103e-04,
  2.326291e-04, 2.240533e-04, 2.157734e-04, 2.077798e-04, 2.000635e-04,
  1.926156e-04, 1.854274e-04, 1.784906e-04, 1.717971e-04, 1.653390e-04,
  1.591086e-04, 1.530985e-04, 1.473015e-04, 1.417106e-04, 1.363190e-04,
  1.311202e-04, 1.261076e-04, 1.212752e-04, 1.166170e-04, 1.121270e-04,
  1.077997e-04, 1.036296e-04, 9.961139e-05, 9.573989e-05, 9.201013e-05,
  8.841729e-05, 8.495668e-05, 8.162377e-05, 7.841418e-05, 7.532364e-05,
  7.234804e-05, 6.948340e-05, 6.672584e-05, 6.407163e-05, 6.151716e-05,
  5.905891e-05, 5.669351e-05, 5.441768e-05, 5.222823e-05, 5.012211e-05,
  4.809634e-05, 4.614806e-05, 4.427448e-05, 4.247293e-05, 4.074080e-05,
  3.907560e-05, 3.747488e-05, 3.593632e-05, 3.445763e-05, 3.303665e-05,
  3.167124e-05, 3.035937e-05, 2.909907e-05, 2.788843e-05, 2.672560e-05,
  2.560882e-05, 2.453636e-05, 2.350657e-05, 2.251785e-05, 2.156866e-05,
  2.065751e-05, 1.978296e-05, 1.894362e-05, 1.813816e-05, 1.736529e-05,
  1.662376e-05, 1.591238e-05, 1.522998e-05, 1.457545e-05, 1.394772e-05,
  1.334575e-05, 1.276853e-05, 1.221512e-05, 1.168457e-05, 1.117599e-05,
  1.068853e-05, 1.022135e-05, 9.773648e-06, 9.344666e-06, 8.933656e-06,
  8.539905e-06, 8.162727e-06, 7.801460e-06, 7.455467e-06, 7.124136e-06,
  6.806877e-06, 6.503122e-06, 6.212327e-06, 5.933965e-06, 5.667533e-06,
  5.412544e-06, 5.168531e-06, 4.935045e-06, 4.711654e-06, 4.497944e-06,
  4.293514e-06, 4.097983e-06, 3.910980e-06, 3.732152e-06, 3.561159e-06,
  3.397673e-06, 3.241381e-06, 3.091982e-06, 2.949184e-06, 2.812711e-06,
  2.682296e-06, 2.557681e-06, 2.438621e-06, 2.324880e-06, 2.216230e-06,
  2.112455e-06, 2.013345e-06, 1.918700e-06, 1.828329e-06, 1.742046e-06,
  1.659675e-06, 1.581047e-06, 1.505999e-06, 1.434375e-06, 1.366025e-06,
  1.300807e-06, 1.238584e-06, 1.179223e-06, 1.122599e-06, 1.068591e-06,
  1.017083e-06, 9.679648e-07, 9.211296e-07, 8.764760e-07, 8.339066e-07,
  7.933282e-07, 7.546515e-07, 7.177911e-07, 6.826653e-07, 6.491956e-07,
  6.173074e-07, 5.869288e-07, 5.579912e-07, 5.304292e-07, 5.041799e-07,
  4.791833e-07, 4.553820e-07, 4.327211e-07, 4.111481e-07, 3.906129e-07,
  3.710674e-07, 3.524659e-07, 3.347645e-07, 3.179214e-07, 3.018965e-07,
  2.866516e-07, 2.721502e-07, 2.583574e-07, 2.452399e-07, 2.327659e-07,
  2.209050e-07, 2.096282e-07, 1.989079e-07, 1.887174e-07, 1.790318e-07,
  1.698267e-07, 1.610794e-07, 1.527678e-07, 1.448711e-07, 1.373692e-07,
  1.302432e-07, 1.234749e-07, 1.170470e-07, 1.109430e-07, 1.051470e-07,
  9.964426e-08, 9.442032e-08, 8.946157e-08, 8.475502e-08, 8.028830e-08,
  7.604961e-08, 7.202770e-08, 6.821188e-08, 6.459194e-08, 6.115818e-08,
  5.790134e-08, 5.481262e-08, 5.188363e-08, 4.910638e-08, 4.647329e-08,
  4.397712e-08, 4.161098e-08, 3.936832e-08, 3.724292e-08, 3.522884e-08,
  3.332045e-08, 3.151237e-08, 2.979952e-08, 2.817703e-08, 2.664029e-08,
  2.518491e-08, 2.380673e-08, 2.250178e-08, 2.126629e-08, 2.009669e-08,
  1.898956e-08, 1.794168e-08, 1.694998e-08, 1.601154e-08, 1.512358e-08,
  1.428348e-08, 1.348873e-08, 1.273697e-08, 1.202593e-08, 1.135348e-08,
  1.071759e-08, 1.011633e-08, 9.547873e-09, 9.010481e-09, 8.502508e-09,
  8.022392e-09, 7.568650e-09, 7.139876e-09, 6.734737e-09, 6.351969e-09,
  5.990371e-09, 5.648809e-09, 5.326203e-09, 5.021532e-09, 4.733828e-09,
  4.462172e-09, 4.205697e-09, 3.963577e-09, 3.735031e-09, 3.519321e-09,
  3.315746e-09, 3.123642e-09, 2.942381e-09, 2.771369e-09, 2.610041e-09,
  2.457865e-09, 2.314336e-09, 2.178976e-09, 2.051332e-09, 1.930978e-09,
  1.817508e-09, 1.710539e-09, 1.609708e-09, 1.514673e-09, 1.425110e-09,
  1.340712e-09, 1.261190e-09, 1.186268e-09, 1.115688e-09, 1.049205e-09,
  9.865876e-10, 9.276166e-10, 8.720854e-10, 8.197984e-10, 7.705711e-10,
  7.242292e-10, 6.806077e-10, 6.395513e-10, 6.009127e-10, 5.645534e-10,
  5.303423e-10, 4.981557e-10, 4.678768e-10, 4.393954e-10, 4.126074e-10,
  3.874147e-10, 3.637247e-10, 3.414500e-10, 3.205080e-10, 3.008211e-10,
  2.823158e-10, 2.649230e-10, 2.485774e-10, 2.332176e-10, 2.187854e-10,
  2.052263e-10, 1.924887e-10, 1.805241e-10, 1.692865e-10, 1.587330e-10,
  1.488228e-10, 1.395177e-10, 1.307817e-10, 1.225806e-10, 1.148826e-10,
  1.076575e-10, 1.008769e-10, 9.451410e-11, 8.854399e-11, 8.294288e-11,
  7.768848e-11, 7.275982e-11, 6.813717e-11, 6.380197e-11, 5.973675e-11,
  5.592508e-11, 5.235149e-11, 4.900146e-11, 4.586131e-11, 4.291819e-11,
  4.016001e-11, 3.757540e-11, 3.515370e-11, 3.288485e-11, 3.075942e-11,
  2.876854e-11, 2.690389e-11, 2.515763e-11, 2.352241e-11, 2.199133e-11,
  2.055789e-11, 1.921600e-11, 1.795994e-11, 1.678434e-11, 1.568416e-11,
  1.465465e-11, 1.369138e-11, 1.279017e-11, 1.194711e-11, 1.115853e-11,
  1.042098e-11, 9.731221e-12, 9.086228e-12, 8.483154e-12, 7.919332e-12,
  7.392258e-12, 6.899587e-12, 6.439120e-12, 6.008794e-12, 5.606677e-12,
  5.230958e-12, 4.879937e-12, 4.552026e-12, 4.245732e-12, 3.959659e-12,
  3.692499e-12, 3.443027e-12, 3.210095e-12, 2.992628e-12, 2.789619e-12,
  2.600127e-12, 2.423269e-12, 2.258218e-12, 2.104203e-12, 1.960500e-12,
  1.826431e-12, 1.701364e-12, 1.584705e-12, 1.475900e-12, 1.374431e-12,
  1.279813e-12, 1.191591e-12, 1.109341e-12, 1.032668e-12, 9.611992e-13,
  8.945890e-13, 8.325130e-13, 7.746685e-13, 7.207723e-13, 6.705600e-13,
  6.237844e-13, 5.802148e-13, 5.396353e-13, 5.018446e-13, 4.666546e-13,
  4.338895e-13, 4.033853e-13, 3.749888e-13, 3.485571e-13, 3.239566e-13,
  3.010628e-13, 2.797594e-13, 2.599379e-13, 2.414970e-13, 2.243424e-13,
  2.083858e-13, 1.935452e-13, 1.797437e-13, 1.669101e-13, 1.549775e-13,
  1.438839e-13, 1.335712e-13, 1.239855e-13, 1.150764e-13, 1.067969e-13,
  9.910343e-14, 9.195511e-14, 8.531402e-14, 7.914477e-14, 7.341441e-14,
  6.809225e-14, 6.314971e-14, 5.856017e-14, 5.429884e-14, 5.034265e-14,
  4.667012e-14, 4.326124e-14, 4.009741e-14, 3.716131e-14, 3.443681e-14,
  3.190892e-14, 2.956368e-14, 2.738812e-14, 2.537016e-14, 2.349857e-14,
  2.176291e-14, 2.015347e-14, 1.866121e-14, 1.727775e-14, 1.599527e-14,
  1.480654e-14, 1.370480e-14, 1.268379e-14, 1.173769e-14, 1.086109e-14,
  1.004897e-14, 9.296654e-15, 8.599817e-15, 7.954429e-15, 7.356751e-15,
  6.803312e-15, 6.290887e-15, 5.816485e-15, 5.377329e-15, 4.970841e-15,
  4.594627e-15, 4.246469e-15, 3.924306e-15, 3.626227e-15, 3.350460e-15,
  3.095359e-15, 2.859399e-15, 2.641167e-15, 2.439350e-15, 2.252732e-15,
  2.080186e-15, 1.920667e-15, 1.773206e-15, 1.636905e-15, 1.510933e-15,
  1.394517e-15, 1.286944e-15, 1.187553e-15, 1.095729e-15, 1.010906e-15,
  9.325576e-16, 8.601964e-16, 7.933718e-16, 7.316665e-16, 6.746938e-16,
  6.220961e-16, 5.735422e-16, 5.287258e-16, 4.873633e-16, 4.491924e-16,
  4.139702e-16, 3.814722e-16, 3.514908e-16, 3.238339e-16, 2.983237e-16,
  2.747959e-16, 2.530988e-16, 2.330918e-16, 2.146452e-16, 1.976389e-16,
  1.819621e-16, 1.675123e-16, 1.541947e-16, 1.419219e-16, 1.306131e-16,
  1.201935e-16, 1.105942e-16, 1.017516e-16, 9.360672e-17, 8.610533e-17,
  7.919726e-17, 7.283623e-17, 6.697951e-17, 6.158764e-17, 5.662423e-17,
  5.205570e-17, 4.785104e-17, 4.398166e-17, 4.042118e-17, 3.714527e-17,
  3.413148e-17, 3.135913e-17, 2.880912e-17, 2.646385e-17, 2.430711e-17,
  2.232393e-17, 2.050054e-17, 1.882422e-17, 1.728326e-17, 1.586688e-17,
  1.456514e-17, 1.336888e-17, 1.226965e-17, 1.125970e-17, 1.033185e-17,
  9.479535e-18, 8.696668e-18, 7.977666e-18, 7.317386e-18, 6.711092e-18,
  6.154426e-18, 5.643376e-18, 5.174252e-18, 4.743657e-18, 4.348466e-18,
  3.985805e-18, 3.653029e-18, 3.347706e-18, 3.067599e-18, 2.810651e-18,
  2.574972e-18, 2.358821e-18, 2.160602e-18, 1.978844e-18, 1.812197e-18,
  1.659421e-18, 1.519374e-18, 1.391009e-18, 1.273363e-18, 1.165552e-18,
  1.066764e-18, 9.762519e-19, 8.933314e-19, 8.173733e-19, 7.477998e-19,
  6.840808e-19, 6.257293e-19, 5.722986e-19, 5.233786e-19, 4.785930e-19,
  4.375965e-19, 4.000722e-19, 3.657295e-19, 3.343018e-19, 3.055445e-19,
  2.792334e-19, 2.551628e-19, 2.331441e-19, 2.130044e-19, 1.945852e-19,
  1.777412e-19, 1.623392e-19, 1.482572e-19, 1.353834e-19, 1.236152e-19,
  1.128588e-19, 1.030282e-19, 9.404465e-20, 8.583590e-20, 7.833591e-20,
  7.148417e-20, 6.522528e-20, 5.950851e-20, 5.428743e-20, 4.951953e-20,
  4.516591e-20, 4.119099e-20, 3.756216e-20, 3.424965e-20, 3.122617e-20,
  2.846677e-20, 2.594866e-20, 2.365095e-20, 2.155457e-20, 1.964207e-20,
  1.789749e-20, 1.630625e-20, 1.485501e-20, 1.353160e-20, 1.232486e-20,
  1.122463e-20, 1.022161e-20, 9.307296e-21, 8.473928e-21, 7.714416e-21,
  7.022284e-21, 6.391617e-21, 5.817015e-21, 5.293545e-21, 4.816706e-21,
  4.382386e-21, 3.986835e-21, 3.626626e-21, 3.298636e-21, 3.000013e-21,
  2.728154e-21, 2.480685e-21, 2.255440e-21, 2.050445e-21, 1.863897e-21,
  1.694154e-21, 1.539716e-21, 1.399218e-21, 1.271415e-21, 1.155171e-21,
  1.049452e-21, 9.533127e-22, 8.658953e-22, 7.864161e-22, 7.141616e-22,
  6.484814e-22, 5.887835e-22, 5.345284e-22, 4.852247e-22, 4.404251e-22,
  3.997221e-22, 3.627449e-22, 3.291558e-22, 2.986474e-22, 2.709399e-22,
  2.457786e-22, 2.229320e-22, 2.021890e-22, 1.833580e-22, 1.662643e-22,
  1.507493e-22, 1.366686e-22, 1.238907e-22, 1.122965e-22, 1.017772e-22,
  9.223414e-23, 8.357761e-23, 7.572604e-23, 6.860527e-23, 6.214794e-23,
  5.629282e-23, 5.098428e-23, 4.617177e-23, 4.180939e-23, 3.785542e-23,
  3.427199e-23, 3.102470e-23, 2.808231e-23, 2.541645e-23, 2.300140e-23,
  2.081375e-23, 1.883231e-23, 1.703781e-23, 1.541278e-23, 1.394136e-23,
  1.260916e-23, 1.140314e-23, 1.031144e-23, 9.323339e-24, 8.429087e-24,
  7.619853e-24, 6.887627e-24, 6.225147e-24, 5.625830e-24, 5.083708e-24,
  4.593371e-24, 4.149917e-24, 3.748904e-24, 3.386306e-24, 3.058476e-24,
  2.762109e-24, 2.494214e-24, 2.252078e-24, 2.033247e-24, 1.835498e-24,
  1.656817e-24, 1.495382e-24, 1.349543e-24, 1.217807e-24, 1.098821e-24,
  9.913625e-25, 8.943242e-25, 8.067044e-25, 7.275969e-25, 6.561819e-25,
  5.917177e-25, 5.335337e-25, 4.810233e-25, 4.336380e-25, 3.908819e-25,
  3.523065e-25, 3.175066e-25, 2.861158e-25, 2.578029e-25, 2.322688e-25,
  2.092429e-25, 1.884810e-25, 1.697624e-25, 1.528876e-25, 1.376766e-25,
  1.239666e-25, 1.116108e-25, 1.004766e-25, 9.044415e-26, 8.140535e-26,
  7.326261e-26, 6.592783e-26, 5.932150e-26, 5.337187e-26, 4.801420e-26,
  4.319006e-26, 3.884677e-26, 3.493679e-26, 3.141724e-26, 2.824945e-26,
  2.539855e-26, 2.283309e-26, 2.052473e-26, 1.844791e-26, 1.657959e-26,
  1.489901e-26, 1.338745e-26, 1.202806e-26, 1.080562e-26, 9.706467e-27,
  8.718253e-27, 7.829872e-27, 7.031319e-27, 6.313583e-27, 5.668549e-27,
  5.088911e-27, 4.568091e-27, 4.100167e-27, 3.679809e-27, 3.302219e-27,
  2.963081e-27, 2.658508e-27, 2.385006e-27, 2.139429e-27, 1.918948e-27,
  1.721018e-27, 1.543350e-27, 1.383887e-27, 1.240777e-27, 1.112355e-27,
  9.971267e-28, 8.937460e-28, 8.010042e-28, 7.178148e-28, 6.432014e-28,
  5.762864e-28, 5.162817e-28, 4.624790e-28, 4.142421e-28, 3.709995e-28,
  3.322381e-28, 2.974968e-28, 2.663620e-28, 2.384619e-28, 2.134630e-28,
  1.910660e-28, 1.710019e-28, 1.530295e-28, 1.369325e-28, 1.225166e-28,
  1.096074e-28, 9.804876e-29, 8.770030e-29, 7.843628e-29, 7.014388e-29,
  6.272194e-29, 5.607976e-29, 5.013600e-29, 4.481775e-29, 4.005967e-29,
  3.580318e-29, 3.199579e-29, 2.859044e-29, 2.554499e-29, 2.282168e-29,
  2.038668e-29, 1.820967e-29, 1.626352e-29, 1.452393e-29, 1.296912e-29,
  1.157960e-29, 1.033794e-29, 9.228495e-30, 8.237299e-30, 7.351834e-30,
  6.560900e-30, 5.854476e-30, 5.223596e-30, 4.660237e-30, 4.157223e-30,
  3.708135e-30, 3.307232e-30, 2.949379e-30, 2.629987e-30, 2.344949e-30,
  2.090595e-30, 1.863647e-30, 1.661170e-30, 1.480544e-30, 1.319428e-30,
  1.175728e-30, 1.047574e-30, 9.332964e-31, 8.314026e-31, 7.405597e-31,
  6.595771e-31, 5.873920e-31, 5.230550e-31, 4.657186e-31, 4.146261e-31,
  3.691022e-31, 3.285439e-31, 2.924134e-31, 2.602303e-31, 2.315663e-31,
  2.060391e-31, 1.833078e-31, 1.630681e-31, 1.450488e-31, 1.290078e-31,
  1.147294e-31, 1.020212e-31, 9.071162e-32, 8.064777e-32, 7.169331e-32,
  6.372675e-32, 5.663981e-32, 5.033600e-32, 4.472934e-32, 3.974323e-32,
  3.530942e-32, 3.136715e-32, 2.786226e-32, 2.474654e-32, 2.197705e-32,
  1.951557e-32, 1.732806e-32, 1.538423e-32, 1.365709e-32, 1.212265e-32,
  1.075954e-32, 9.548756e-33, 8.473382e-33, 7.518368e-33, 6.670329e-33,
  5.917358e-33, 5.248863e-33, 4.655427e-33, 4.128675e-33, 3.661160e-33,
  3.246262e-33, 2.878096e-33, 2.551431e-33, 2.261618e-33, 2.004526e-33,
  1.776482e-33, 1.574225e-33, 1.394857e-33, 1.235804e-33, 1.094778e-33,
  9.697497e-34, 8.589146e-34, 7.606715e-34, 6.735987e-34, 5.964336e-34,
  5.280559e-34, 4.674708e-34, 4.137957e-34, 3.662472e-34, 3.241302e-34,
  2.868280e-34, 2.537934e-34, 2.245413e-34, 1.986409e-34, 1.757107e-34,
  1.554120e-34, 1.374446e-34, 1.215424e-34, 1.074693e-34, 9.501632e-35,
  8.399796e-35, 7.424995e-35, 6.562667e-35, 5.799913e-35, 5.125302e-35,
  4.528707e-35, 4.001159e-35, 3.534714e-35, 3.122336e-35, 2.757794e-35,
  2.435571e-35, 2.150784e-35, 1.899107e-35, 1.676714e-35, 1.480217e-35,
  1.306618e-35, 1.153264e-35, 1.017807e-35, 8.981718e-36, 7.925196e-36,
  6.992258e-36, 6.168531e-36, 5.441303e-36, 4.799333e-36, 4.232682e-36,
  3.732564e-36, 3.291211e-36, 2.901757e-36, 2.558134e-36, 2.254978e-36,
  1.987550e-36, 1.751664e-36, 1.543620e-36, 1.360149e-36, 1.198367e-36,
  1.055723e-36, 9.299651e-37, 8.191064e-37, 7.213912e-37, 6.352698e-37,
  5.593741e-37, 4.924968e-37, 4.335720e-37, 3.816593e-37, 3.359289e-37,
  2.956485e-37, 2.601722e-37, 2.289301e-37, 2.014196e-37, 1.771974e-37,
  1.558726e-37, 1.371005e-37, 1.205772e-37, 1.060348e-37, 9.323695e-38,
  8.197562e-38, 7.206728e-38, 6.335026e-38, 5.568209e-38, 4.893724e-38,
  4.300512e-38, 3.778834e-38, 3.320108e-38, 2.916778e-38, 2.562191e-38,
  2.250486e-38, 1.976505e-38, 1.735707e-38, 1.524094e-38, 1.338148e-38,
  1.174770e-38, 1.031238e-38, 9.051517e-39, 7.944029e-39, 6.971353e-39,
  6.117164e-39, 5.367104e-39, 4.708545e-39, 4.130383e-39, 3.622852e-39,
  3.177370e-39, 2.786389e-39, 2.443276e-39, 2.142201e-39, 1.878039e-39,
  1.646288e-39, 1.442992e-39, 1.264675e-39, 1.108283e-39, 9.711337e-40,
  8.508722e-40, 7.454294e-40, 6.529884e-40, 5.719541e-40, 5.009262e-40,
  4.386753e-40, 3.841221e-40, 3.363197e-40, 2.944369e-40, 2.577441e-40,
  2.256016e-40, 1.974479e-40, 1.727904e-40, 1.511971e-40, 1.322891e-40,
  1.157342e-40, 1.012409e-40, 8.855375e-41, 7.744883e-41, 6.772977e-41,
  5.922446e-41, 5.178207e-41, 4.527043e-41, 3.957369e-41, 3.459037e-41,
  3.023158e-41, 2.641941e-41, 2.308566e-41, 2.017058e-41, 1.762183e-41,
  1.539362e-41, 1.344581e-41, 1.174330e-41, 1.025534e-41, 8.955028e-42,
  7.818807e-42, 6.826072e-42, 5.958790e-42, 5.201182e-42, 4.539446e-42,
  3.961507e-42, 3.456804e-42, 3.016102e-42, 2.631322e-42, 2.295402e-42,
  2.002167e-42, 1.746219e-42, 1.522839e-42, 1.327902e-42, 1.157803e-42,
  1.009393e-42, 8.799188e-43, 7.669759e-43, 6.684635e-43, 5.825463e-43,
  5.076215e-43, 4.422892e-43, 3.853270e-43, 3.356676e-43, 2.923790e-43,
  2.546476e-43, 2.217634e-43, 1.931066e-43, 1.681361e-43, 1.463800e-43,
  1.274263e-43, 1.109158e-43, 9.653492e-44, 8.401026e-44, 7.310330e-44,
  6.360605e-44, 5.533713e-44, 4.813840e-44, 4.187197e-44, 3.641766e-44,
  3.167068e-44, 2.753972e-44, 2.394520e-44, 2.081777e-44, 1.809701e-44,
  1.573027e-44, 1.367169e-44, 1.188133e-44, 1.032440e-44, 8.970597e-45,
  7.793537e-45, 6.770249e-45, 5.880733e-45, 5.107579e-45, 4.435632e-45,
  3.851702e-45, 3.344311e-45, 2.903470e-45, 2.520490e-45, 2.187808e-45,
  1.898849e-45, 1.647890e-45, 1.429957e-45, 1.240722e-45, 1.076422e-45,
  9.337864e-46, 8.099708e-46, 7.025026e-46, 6.092328e-46, 5.282937e-46,
  4.580621e-46, 3.971275e-46, 3.442647e-46, 2.984089e-46, 2.586353e-46,
  2.241406e-46, 1.942273e-46, 1.682893e-46, 1.458007e-46, 1.263047e-46,
  1.094048e-46, 9.475667e-47, 8.206161e-47, 7.106030e-47, 6.152772e-47,
  5.326862e-47, 4.611357e-47, 3.991562e-47, 3.454728e-47, 2.989796e-47,
  2.587176e-47, 2.238552e-47, 1.936713e-47, 1.675406e-47, 1.449211e-47,
  1.253429e-47, 1.083989e-47, 9.373608e-48, 8.104859e-48, 7.007141e-48,
  6.057495e-48, 5.236029e-48, 4.525512e-48, 3.911022e-48, 3.379633e-48,
  2.920153e-48, 2.522890e-48, 2.179455e-48, 1.882584e-48, 1.625988e-48,
  1.404227e-48, 1.212590e-48, 1.047002e-48, 9.039357e-49, 7.803412e-49,
  6.735785e-49, 5.813648e-49, 5.017253e-49, 4.329523e-49, 3.735690e-49,
  3.222986e-49, 2.780371e-49, 2.398302e-49, 2.068529e-49, 1.783924e-49,
  1.538324e-49, 1.326404e-49, 1.143565e-49, 9.858310e-50, 8.497690e-50,
  7.324131e-50, 6.312016e-50, 5.439223e-50, 4.686648e-50, 4.037798e-50,
  3.478433e-50, 2.996259e-50, 2.580667e-50, 2.222497e-50, 1.913848e-50,
  1.647897e-50, 1.418763e-50, 1.221367e-50, 1.051331e-50, 9.048762e-51,
  7.787459e-51, 6.701302e-51, 5.766063e-51, 4.960852e-51, 4.267661e-51,
  3.670966e-51, 3.157385e-51, 2.715386e-51, 2.335029e-51, 2.007750e-51,
  1.726172e-51, 1.483935e-51, 1.275565e-51, 1.096345e-51, 9.422116e-52,
  8.096670e-52, 6.956987e-52, 5.977130e-52, 5.134770e-52, 4.410685e-52,
  3.788330e-52, 3.253467e-52, 2.793841e-52, 2.398909e-52, 2.059598e-52,
  1.768105e-52, 1.517716e-52, 1.302655e-52, 1.117958e-52, 9.593518e-53,
  8.231656e-53, 7.062416e-53, 6.058654e-53, 5.197036e-53, 4.457507e-53,
  3.822832e-53, 3.278197e-53, 2.810875e-53, 2.409933e-53, 2.065975e-53,
  1.770932e-53, 1.517873e-53, 1.300846e-53, 1.114738e-53, 9.551614e-54,
  8.183468e-54, 7.010592e-54, 6.005218e-54, 5.143511e-54, 4.405013e-54,
  3.772173e-54, 3.229927e-54, 2.765352e-54, 2.367364e-54, 2.026452e-54,
  1.734461e-54, 1.484394e-54, 1.270255e-54, 1.086899e-54, 9.299172e-55,
  7.955291e-55, 6.804945e-55, 5.820361e-55, 4.977737e-55, 4.256678e-55,
  3.639706e-55, 3.111850e-55, 2.660282e-55, 2.274015e-55, 1.943640e-55,
  1.661098e-55, 1.419486e-55, 1.212897e-55, 1.036271e-55, 8.852779e-56,
  7.562103e-56, 6.458956e-56, 5.516184e-56, 4.710554e-56, 4.022184e-56,
  3.434066e-56, 2.931649e-56, 2.502489e-56, 2.135940e-56, 1.822900e-56,
  1.555583e-56, 1.327334e-56, 1.132463e-56, 9.661060e-57, 8.241042e-57,
  7.029043e-57, 5.994694e-57, 5.112044e-57, 4.358920e-57, 3.716379e-57,
  3.168238e-57, 2.700675e-57, 2.301885e-57, 1.961786e-57, 1.671769e-57,
  1.424485e-57, 1.213657e-57, 1.033929e-57, 8.807296e-58, 7.501550e-58,
  6.388754e-58, 5.440491e-58, 4.632514e-58, 3.944138e-58, 3.357718e-58,
  2.858203e-58, 2.432756e-58, 2.070432e-58, 1.761895e-58, 1.499187e-58,
  1.275523e-58, 1.085119e-58, 9.230463e-59, 7.851022e-59, 6.677066e-59,
  5.678085e-59, 4.828084e-59, 4.104917e-59, 3.489722e-59, 2.966429e-59,
  2.521354e-59, 2.142843e-59, 1.820974e-59, 1.547297e-59, 1.314621e-59,
  1.116822e-59, 9.486898e-60, 8.057888e-60, 6.843447e-60, 5.811461e-60,
  4.934606e-60, 4.189637e-60, 3.556780e-60, 3.019218e-60, 2.562645e-60,
  2.174900e-60, 1.845639e-60, 1.566070e-60, 1.328716e-60, 1.127223e-60,
  9.561903e-61, 8.110274e-61, 6.878337e-61, 5.832947e-61, 4.945947e-61,
  4.193412e-61, 3.555023e-61, 3.013519e-61, 2.554243e-61, 2.164747e-61,
  1.834463e-61, 1.554417e-61, 1.316990e-61, 1.115718e-61, 9.451118e-62,
  8.005133e-62, 6.779702e-62, 5.741290e-62, 4.861441e-62, 4.116018e-62,
  3.484547e-62, 2.949660e-62, 2.496631e-62, 2.112971e-62, 1.788091e-62,
  1.513011e-62, 1.280122e-62, 1.082973e-62, 9.160946e-63, 7.748539e-63,
  6.553240e-63, 5.541777e-63, 4.685961e-63, 3.961915e-63, 3.349409e-63,
  2.831314e-63, 2.393121e-63, 2.022544e-63, 1.709181e-63, 1.444224e-63,
  1.220220e-63, 1.030857e-63, 8.707936e-64, 7.355105e-64, 6.211825e-64,
  5.245734e-64, 4.429452e-64, 3.739819e-64, 3.157241e-64, 2.665150e-64,
  2.249533e-64, 1.898540e-64, 1.602153e-64, 1.351900e-64, 1.140623e-64,
  9.622690e-65, 8.117223e-65, 6.846603e-65, 5.774303e-65, 4.869459e-65,
  4.105996e-65, 3.461889e-65, 2.918532e-65, 2.460211e-65, 2.073658e-65,
  1.747666e-65, 1.472776e-65, 1.240999e-65, 1.045594e-65, 8.808693e-66,
  7.420215e-66, 6.249974e-66, 5.263767e-66, 4.432736e-66, 3.732534e-66,
  3.142623e-66, 2.645682e-66, 2.227100e-66, 1.874556e-66, 1.577662e-66,
  1.327658e-66, 1.117159e-66, 9.399409e-67, 7.907567e-67, 6.651842e-67,
  5.594968e-67, 4.705547e-67, 3.957120e-67, 3.327401e-67, 2.797614e-67,
  2.351944e-67, 1.977075e-67, 1.661789e-67, 1.396643e-67, 1.173685e-67,
  9.862211e-68, 8.286171e-68, 6.961297e-68, 5.847675e-68, 4.911712e-68,
  4.125146e-68, 3.464196e-68, 2.908857e-68, 2.442299e-68, 2.050370e-68,
  1.721164e-68, 1.444671e-68, 1.212474e-68, 1.017495e-68, 8.537864e-69,
  7.163459e-69, 6.009703e-69, 5.041270e-69, 4.228474e-69, 3.546370e-69,
  2.974001e-69, 2.493761e-69, 2.090862e-69, 1.752882e-69, 1.469388e-69,
  1.231621e-69, 1.032225e-69, 8.650247e-70, 7.248352e-70, 6.073048e-70,
  5.087810e-70, 4.261984e-70, 3.569845e-70, 2.989810e-70, 2.503771e-70,
  2.096536e-70, 1.755362e-70, 1.469562e-70, 1.230172e-70, 1.029675e-70,
  8.617701e-71, 7.211729e-71, 6.034538e-71, 5.049000e-71, 4.223995e-71,
  3.533444e-71, 2.955491e-71, 2.471826e-71, 2.067106e-71, 1.728480e-71,
  1.445182e-71, 1.208196e-71, 1.009972e-71, 8.441850e-72, 7.055418e-72,
  5.896096e-72, 4.926779e-72, 4.116407e-72, 3.438984e-72, 2.872756e-72,
  2.399519e-72, 2.004039e-72, 1.673574e-72, 1.397463e-72, 1.166789e-72,
  9.740949e-73, 8.131428e-73, 6.787175e-73, 5.664583e-73, 4.727196e-73,
  3.944536e-73, 3.291130e-73, 2.745685e-73, 2.290410e-73, 1.910435e-73,
  1.593339e-73, 1.328742e-73, 1.107975e-73, 9.237957e-74, 7.701558e-74,
  6.420043e-74, 5.351235e-74, 4.459917e-74, 3.716689e-74, 3.097008e-74,
  2.580389e-74, 2.149734e-74, 1.790775e-74, 1.491605e-74, 1.242292e-74,
  1.034546e-74, 8.614558e-75, 7.172536e-75, 5.971304e-75, 4.970755e-75,
  4.137444e-75, 3.443489e-75, 2.865642e-75, 2.384525e-75, 1.983986e-75,
  1.650562e-75, 1.373036e-75, 1.142059e-75, 9.498434e-76, 7.899000e-76,
  6.568238e-76, 5.461129e-76, 4.540175e-76, 3.774153e-76, 3.137062e-76,
  2.607254e-76, 2.166708e-76, 1.800421e-76, 1.495907e-76, 1.242772e-76,
  1.032370e-76, 8.575033e-77, 7.121852e-77, 5.914347e-77, 4.911084e-77,
  4.077600e-77, 3.385233e-77, 2.810148e-77, 2.332526e-77, 1.935889e-77,
  1.606539e-77, 1.333088e-77, 1.106070e-77, 9.176215e-78, 7.612040e-78,
  6.313864e-78, 5.236561e-78, 4.342639e-78, 3.600957e-78, 2.985650e-78,
  2.475236e-78, 2.051875e-78, 1.700756e-78, 1.409580e-78, 1.168138e-78,
  9.679551e-79, 8.019975e-79, 6.644274e-79, 5.504004e-79, 4.558969e-79,
  3.775819e-79, 3.126889e-79, 2.589229e-79, 2.143804e-79, 1.774828e-79,
  1.469212e-79, 1.216100e-79, 1.006493e-79, 8.329303e-80, 6.892288e-80,
  5.702626e-80, 4.717839e-80, 3.902725e-80, 3.228119e-80, 2.669855e-80,
  2.207917e-80, 1.825721e-80, 1.509533e-80, 1.247980e-80, 1.031643e-80,
  8.527224e-81, 7.047624e-81, 5.824176e-81, 4.812635e-81, 3.976382e-81,
  3.285110e-81, 2.713741e-81, 2.241525e-81, 1.851294e-81, 1.528847e-81,
  1.262436e-81, 1.042344e-81, 8.605377e-82, 7.103710e-82, 5.863504e-82,
  4.839338e-82, 3.993662e-82, 3.295440e-82, 2.719018e-82, 2.243198e-82,
  1.850460e-82, 1.526330e-82, 1.258850e-82, 1.038141e-82, 8.560421e-83,
  7.058147e-83, 5.818927e-83, 4.796803e-83, 3.953825e-83, 3.258666e-83,
  2.685461e-83, 2.212863e-83, 1.823252e-83, 1.502090e-83, 1.237376e-83,
  1.019211e-83, 8.394273e-84, 6.912878e-84, 5.692347e-84, 4.686844e-84,
  3.858570e-84, 3.176354e-84, 2.614497e-84, 2.151810e-84, 1.770829e-84,
  1.457155e-84, 1.198924e-84, 9.863576e-85, 8.113976e-85, 6.674054e-85,
  5.489115e-85, 4.514106e-85, 3.711913e-85, 3.051972e-85, 2.509111e-85,
  2.062605e-85, 1.695387e-85, 1.393408e-85, 1.145102e-85, 9.409514e-86,
  7.731196e-86, 6.351596e-86, 5.217659e-86, 4.285735e-86, 3.519909e-86,
  2.890643e-86, 2.373635e-86, 1.948903e-86, 1.600012e-86, 1.313448e-86,
  1.078100e-86, 8.848347e-87, 7.261425e-87, 5.958517e-87, 4.888901e-87,
  4.010892e-87, 3.290238e-87, 2.698798e-87, 2.213452e-87, 1.815209e-87,
  1.488469e-87, 1.220421e-87, 1.000544e-87, 8.201989e-88, 6.722936e-88,
  5.510050e-88, 4.515530e-88, 3.700144e-88, 3.031692e-88, 2.483753e-88,
  2.034643e-88, 1.666575e-88, 1.364954e-88, 1.117810e-88, 9.153236e-89,
  7.494419e-89, 6.135613e-89, 5.022670e-89, 4.111194e-89, 3.364790e-89,
  2.753624e-89
};

static double area_under_normal(double z)
{
  if (z <= 0)
  {
    uint32_t idx = (uint32_t)(z * -100.0);
    if (idx >= sizeof(normal_pvalues)/sizeof(normal_pvalues[0]))
      idx = sizeof(normal_pvalues)/sizeof(normal_pvalues[0]) - 1;

    return normal_pvalues[idx];
  }

  return 1.0 - area_under_normal(-z);
}

static double area_under_normal(double lowz, double upz)
{
  if (upz <= lowz)
    return 0.0;

  return area_under_normal(upz) - area_under_normal(lowz);
}

// log of two-tailed standard normal p-values from 0 to 2 in 0.01 increments.
double normal_logpvalues[] = 
{
  0.000000000, -0.008010713, -0.016085305, -0.024223993, -0.032426991,
  -0.040694515, -0.049026776, -0.057423986, -0.065886356, -0.074414095,
  -0.083007412, -0.091666514, -0.100391606, -0.109182893, -0.118040580,
  -0.126964868, -0.135955959, -0.145014053, -0.154139350, -0.163332048,
  -0.172592342, -0.181920430, -0.191316505, -0.200780761, -0.210313390,
  -0.219914584, -0.229584533, -0.239323425, -0.249131449, -0.259008791,
  -0.268955638, -0.278972172, -0.289058579, -0.299215039, -0.309441736,
  -0.319738847, -0.330106554, -0.340545033, -0.351054461, -0.361635015,
  -0.372286869, -0.383010196, -0.393805170, -0.404671961, -0.415610740,
  -0.426621677, -0.437704940, -0.448860697, -0.460089112, -0.471390352,
  -0.482764581, -0.494211962, -0.505732656, -0.517326826, -0.528994631,
  -0.540736230, -0.552551781, -0.564441441, -0.576405366, -0.588443712,
  -0.600556631, -0.612744278, -0.625006803, -0.637344359, -0.649757096,
  -0.662245161, -0.674808704, -0.687447872, -0.700162811, -0.712953666,
  -0.725820581, -0.738763700, -0.751783165, -0.764879119, -0.778051700,
  -0.791301049, -0.804627305, -0.818030606, -0.831511088, -0.845068887,
  -0.858704139, -0.872416977, -0.886207535, -0.900075946, -0.914022340,
  -0.928046849, -0.942149603, -0.956330730, -0.970590358, -0.984928614,
  -0.999345626, -1.013841518, -1.028416415, -1.043070441, -1.057803719,
  -1.072616372, -1.087508520, -1.102480283, -1.117531783, -1.132663137,
  -1.147874464, -1.163165882, -1.178537506, -1.193989452, -1.209521836,
  -1.225134772, -1.240828372, -1.256602751, -1.272458018, -1.288394287,
  -1.304411666, -1.320510267, -1.336690197, -1.352951564, -1.369294477,
  -1.385719042, -1.402225364, -1.418813549, -1.435483702, -1.452235927,
  -1.469070325, -1.485987001, -1.502986055, -1.520067589, -1.537231703,
  -1.554478497, -1.571808069, -1.589220517, -1.606715941, -1.624294436,
  -1.641956098, -1.659701024, -1.677529308, -1.695441045, -1.713436329,
  -1.731515252, -1.749677907, -1.767924385, -1.786254779, -1.804669178,
  -1.823167672, -1.841750352, -1.860417304, -1.879168619, -1.898004382,
  -1.916924681, -1.935929603, -1.955019233, -1.974193656, -1.993452957,
  -2.012797220, -2.032226528, -2.051740965, -2.071340612, -2.091025551,
  -2.110795863, -2.130651630, -2.150592930, -2.170619844, -2.190732452,
  -2.210930830, -2.231215057, -2.251585211, -2.272041368, -2.292583606,
  -2.313211998, -2.333926622, -2.354727552, -2.375614862, -2.396588626,
  -2.417648917, -2.438795808, -2.460029372, -2.481349681, -2.502756805,
  -2.524250815, -2.545831783, -2.567499778, -2.589254869, -2.611097125,
  -2.633026616, -2.655043408, -2.677147571, -2.699339170, -2.721618273,
  -2.743984945, -2.766439254, -2.788981263, -2.811611038, -2.834328644,
  -2.857134145, -2.880027604, -2.903009084, -2.926078649, -2.949236360,
  -2.972482281, -2.995816471, -3.019238993, -3.042749907, -3.066349274,
  -3.090037153
};

class ZScoreMetric
{
public:
  void setup(uint32_t nIn, uint32_t nOut, std::list<std::vector<double> >& aData)
  {
    uint32_t i;
    double inIn = 1.0 / nIn;

    for (i = 0; i < nIn; i++)
    {
      double X = 0.0, X2 = 0.0;
      std::list<std::vector<double> >::iterator j;
      for (j = aData.begin(); j != aData.end(); j++)
      {
        std::vector<double>& v(*j);
        double Xi = v[i];
        X += Xi;
        X2 += Xi * Xi;
      }

      X *= inIn;
      X2 *= inIn;
      double varX = X2 - X * X;
      if (varX < 1E-10)
        varX = 1E-10;
      isigma.push_back(1.0 / sqrt(varX));
    }
  }

  double
  operator()(uint32_t aCount,
             double* aArray,
             const std::vector<double>& aVector)
  {
    double score = 0.0;
    uint32_t i;
    for (i = 0; i < aCount; i++)
    {
      double t = aVector[i] - aArray[i];
      if (t < 0.0)
        t = -t;
      score +=  t * isigma[i];
    }

    return score;
  }

protected:
  std::vector<double> isigma;
};

class NormalLogPMetric
  : public ZScoreMetric
{
public:
  double
  operator()(uint32_t aCount,
             double* aArray,
             const std::vector<double>& aVector)
  {
    double score = 0.0;
    uint32_t i;
    for (i = 0; i < aCount; i++)
    {
      double t = (aVector[i] - aArray[i]) * isigma[i];
      if (t < 0.0)
        t = -t;
      uint32_t idx = (uint32_t)(t * 100.0);
      if (idx >= (sizeof(normal_logpvalues)/sizeof(normal_logpvalues[0])))
        idx = (sizeof(normal_logpvalues)/sizeof(normal_logpvalues[0])) - 1;
      score += normal_logpvalues[idx];
    }

    // We have negative numbers, where smaller (more negative) numbers are
    // more significantly different. We take the negative of this to get a
    // distance...
    return -score;
  }
};

class CovWeightedManhattanMetric
{
public:
  CovWeightedManhattanMetric()
    : mCOV(NULL)
  {
  }

  ~CovWeightedManhattanMetric()
  {
    if (mCOV != NULL)
      delete [] mCOV;
  }

  void setup(uint32_t nIn, uint32_t nOut, std::list<std::vector<double> >& aData)
  {
    double* mu = new double[nIn];
    double* nu = new double[nOut];

    uint32_t i, j;
    std::list<std::vector<double> >::iterator it;

    double inTrain = 1.0 / aData.size(), inOut = 1.0 / nOut;

    for (i = 0; i < nIn; i++)
    {
      double sum = 0.0;
      for (it = aData.begin(); it != aData.end(); it++)
        sum += (*it)[i];
      mu[i] = inTrain * sum;
    }

    for (i = 0; i < nOut; i++)
    {
      double sum = 0.0;
      for (it = aData.begin(); it != aData.end(); it++)
        sum += (*it)[i + nIn];
      nu[i] = inTrain * sum;
    }

    mCOV = new double[nIn];

    memset(mCOV, 0, sizeof(double) * nIn);

    for (i = 0; i < nIn; i++)
    {
      for (j = 0; j < nOut; j++)
      {
        double sum = 0.0;
        for (it = aData.begin(); it != aData.end(); it++)
          sum += fabs(((*it)[i] - mu[i]) * ((*it)[j + nIn] - nu[j]));
        mCOV[i] += inTrain * sum;
      }
      mCOV[i] /= inOut;
    }
  }

  double
  operator()(uint32_t aCount,
             double* aArray,
             const std::vector<double>& aVector)
  {
    double score = 0.0;
    uint32_t i;
    for (i = 0; i < aCount; i++)
    {
      double t = aVector[i] - aArray[i];
      if (t < 0.0)
        t = -t;
      score += t * mCOV[i];
    }

    return score;
  }

private:
  double* mCOV;
};

template<class Metric>
class KNearestNeighbours
  : public BlackBoxModelBase
{
public:
  KNearestNeighbours(std::wstring& aID, uint32_t aInputs, uint32_t aOutputs);
  ~KNearestNeighbours();
  void Serialise(std::string& storeIn);
  void Deserialise(const std::string& aInput);
  void train(double * IN, double * OUT);
  void run(double * IN, double * OUT);
  double GetAverageInput(uint32_t index);

private:
  uint32_t mInputs, mOutputs, mTotal;
  std::list<std::vector<double> > mDataCloud;
  Metric metric;
  bool mStateDirty;
};

class KNearestNeighboursFactory
  : public BlackBoxModelFactory
{
public:
  KNearestNeighboursFactory()
  {
    MixedModelBase::RegisterModelFactory
    (
     L"http://www.bioeng.auckland.ac.nz/people/miller/black_box/k-nearest-neighbours",
     this
    );
  }

  BlackBoxModelBase*
  createBlackBoxModel
  (
   std::wstring& aID,
   uint32_t aInputs,
   uint32_t aOutputs
  )
  {
    return new KNearestNeighbours<PearsonCorrMetric>(aID, aInputs, aOutputs);
  }
};

KNearestNeighboursFactory gKNNFactory;

template<class Metric>
KNearestNeighbours<Metric>::KNearestNeighbours
(
 std::wstring& aID,
 uint32_t aInputs,
 uint32_t aOutputs
)
  : mInputs(aInputs), mOutputs(aOutputs), mTotal(aInputs + aOutputs),
    mStateDirty(false)
{
}

template<class Metric>
KNearestNeighbours<Metric>::~KNearestNeighbours()
{
}

template<class Metric>
void
KNearestNeighbours<Metric>::Serialise(std::string& ser)
{
  ser.assign("");

  if (!mStateDirty)
    return;

  ser += std::string(reinterpret_cast<char*>(&mInputs), sizeof(uint32_t));
  ser += std::string(reinterpret_cast<char*>(&mOutputs), sizeof(uint32_t));
  std::list<std::vector<double> >::iterator i;
  std::vector<double>::iterator j;
  for (i = mDataCloud.begin(); i != mDataCloud.end(); i++)
    // A simple memcpy would be good, and might work for many STL
    // implementations, but the spec doesn't provide a standard way to do it.
    for (j = (*i).begin(); j != (*i).end(); j++)
    {
      double d = (*j);
      ser += std::string(reinterpret_cast<char*>(&d), sizeof(double));
    }
}

template<class Metric>
void
KNearestNeighbours<Metric>::Deserialise(const std::string& aInput)
{
  uint32_t l = aInput.length();
  const char* p = aInput.data();
  if (l < (sizeof(uint32_t) * 2))
  {
    printf("Can't use KNN stored training: Bad header.\n");
    return;
  }
  uint32_t inputs, outputs;
  inputs = *reinterpret_cast<const uint32_t*>(p);
  p += sizeof(uint32_t);
  outputs = *reinterpret_cast<const uint32_t*>(p);
  p += sizeof(uint32_t);
  l -= sizeof(uint32_t) * 2;

  if (inputs != mInputs || outputs != mOutputs)
  {
    printf("Can't use KNN stored training: Incompatible input "
           "and/or output counts.\n");
    return;
  }

  l /= sizeof(double) * mTotal;
  uint32_t i;
  const double * dd = reinterpret_cast<const double*>(p);
  const double * dde = dd + l * mTotal;
  for (; dd < dde; dd += mTotal)
  {
    std::vector<double> dv;
    const double * dl = dd, * dle = dd + mTotal;
    for (; dl < dle; dl++)
      dv.push_back(*dl);
    mDataCloud.push_back(dv);
  }
}

template<class Metric>
void
KNearestNeighbours<Metric>::train(double * IN, double * OUT)
{
  std::vector<double> vec;
  uint32_t i;
  for (i = 0; i < mInputs; i++)
    vec.push_back(IN[i]);
  for (i = 0; i < mOutputs; i++)
    vec.push_back(OUT[i]);
  mDataCloud.push_back(vec);
  mStateDirty = true;
}

struct ComparePairByFirst
{
public:
  bool
  operator()(const std::pair<double, std::vector<double>*>& p1,
             const std::pair<double, std::vector<double>*>& p2)
  {
    return (p1.first < p2.first);
  }
};

#include <assert.h>

template<class Metric>
void
KNearestNeighbours<Metric>::run(double * IN, double * OUT)
{
  metric.setup(mInputs, mOutputs, mDataCloud);

  std::vector<std::pair<double, std::vector<double>*> > bestHits;
  ComparePairByFirst cpbf;

  uint32_t i;

  if (mInputs == 0)
  {
    for (i = 0; i < mTotal; i++)
    {
      double sum = 0.0;
      std::list<std::vector<double> >::iterator dci(mDataCloud.begin());
      if (mDataCloud.size() == 0)
        printf("Warning: No training data for output %u\n", i - mInputs);
      for (; dci != mDataCloud.end(); dci++)
      {
        sum += (*dci)[i];
      }
      OUT[i - mInputs] = sum / mDataCloud.size();
    }
    return;
  }

  std::list<std::vector<double> >::iterator dci = mDataCloud.begin();
  for (i = 0; i < KNN_KVALUE; i++)
  {
    if (dci == mDataCloud.end())
      break;

    double score = metric(mInputs, IN, *dci);
    //printf("Pushing score %g onto initial KNN best heap.\n", score);
    bestHits.push_back(std::pair<double, std::vector<double>*>(score, &*dci));
    // std::push_heap(bestHits.begin(), bestHits.end(), cpbf);
    dci++;
  }

#if 0
  while (dci != mDataCloud.end())
  {
    double score = metric(mInputs, IN, *dci);
    if (bestHits.front().first <= score)
    {
      //printf("Score %g not good enough for the heap (%g better)\n",
      //        score, bestHits.front().first);
      dci++;
      continue;
    }

    //printf("Score %g good enough for the heap (%g worse)\n",
    //       score, bestHits.front().first);

    std::pop_heap(bestHits.begin(), bestHits.end(), cpbf);
    bestHits.pop_back();
    bestHits.push_back(std::pair<double, std::vector<double>*>(score, &*dci));
    std::push_heap(bestHits.begin(), bestHits.end(), cpbf);
    dci++;
  }
#endif

  std::vector<std::pair<double, std::vector<double>*> >::iterator bhi;

#ifndef WEIGHT_PROPORTIONAL_AVERAGING
  // std::sort(bestHits.begin(), bestHits.end(), cpbf);
#endif

  for (i = mInputs; i < mTotal; i++)
  {
    // Compute the mean and standard deviation of the outputs.
    double X = 0.0, X2 = 0.0;
    for (bhi = bestHits.begin(); bhi != bestHits.end(); bhi++)
    {
      double v = (*((*bhi).second))[i];
      X += v;
      X2 += v * v;
    }
    double isbh = 1.0 / bestHits.size();
    double mean = X * isbh;
    double stdev = sqrt(X2 * isbh - mean*mean);

    // If it is flat, there is nothing we can do but use the mean.
    if (stdev == 0.0)
    {
      OUT[i - mInputs] = mean;
      continue;
    }

    double istdev = 1.0 / stdev;

    // Assuming normality, create an a priori distribution...
    double llmat[200];
    double mid = -9.95;

    uint32_t j;
    for (j = 0; j < 200; j++)
    {
      // If x = log(integrate{z=L,z=H}(standard normal PDF)), then x tends to
      // ((H-L)/2 - mu / sigma) ^ 2 + c (c a constant) as H-L tends to zero. We
      // assume that H-L is sufficiently small to approximate x by the limiting
      // value. We don't care about the constant c because we will normalise it
      // off later anyway.
      
      double t = ((mid - mean) * istdev);
      llmat[j] = t * t;

      mid += 0.1;
    }

    // Now we update the priors by the best hit scores...
    for (bhi = bestHits.begin(); bhi != bestHits.end(); bhi++)
    {
      // The centre of the distribution is the training point.
      double v = (*((*bhi).second))[i];

      if (!finite(v))
        printf("Warning: v isn't finite.\n");

      // Our empirical standard deviation which gives more distant points a
      // more flat contribution to the final distribution. Note that we work
      // the inverse of the standard deviation for efficiency reasons.
      double d = (*bhi).first;

      if (d < 0.01)
        d = 0.01;
      else if (!finite(d))
        continue;

      double itstdev = (1.0) / (stdev * d * 1000.0);

      double mid = -9.95;
      for (j = 0; j < 200; j++)
      {
        double t = itstdev * (mid - v);
        llmat[j] += t * t;
        assert(finite(llmat[j]));
        mid += 0.1;
      }
    }

    // Find the maximal log posterior probability...
    double maxPost = -INFINITY;
    for (j = 0; j < 200; j++)
    {
      // We inverted the sign, so fix it...
      llmat[j] = -llmat[j];
      if (llmat[j] > maxPost)
        maxPost = llmat[j];
    }

    // Subtract the minimum log posterior, take the exponent, and sum...
    double normfac = 0.0;
    for (j = 0; j < 200; j++)
    {
      // This prevents our entire dataset from underflowing.
      llmat[j] -= maxPost;
      llmat[j] = exp(llmat[j]);
      if (!isfinite(llmat[j]))
        llmat[j] = 0.0;
      normfac += llmat[j];
    }

    normfac = 1.0 / normfac;

    double expect = 0.0;

    // Normalise to 1 and compute the expectation...
    mid = -9.95;
    for (j = 0; j < 200; j++)
    {
      llmat[j] *= normfac;
      expect += llmat[j] * mid;
      mid += 0.1;
    }

    OUT[i - mInputs] = expect;
  }
}

template<class Metric>
double
KNearestNeighbours<Metric>::GetAverageInput(uint32_t index)
{
  std::list<std::vector<double> >::iterator dci = mDataCloud.begin();
  double avg = 0.0;

  if (index < mInputs)
  {
    for (; dci != mDataCloud.end(); dci++)
      avg += (*dci)[index];
    avg /= mDataCloud.size();
  }

  return avg;
}
